unit LSRMTools_RS;

//Copyright 2013-2017 Ren Dahms (rene.dahms at math.ethz.ch)
//
//This file is part of LSRMTools.
//
//    LSRMTools is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    LSRMTools is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with LSRMTools.  If not, see <http://www.gnu.org/licenses/>.
//
//LSRMTools use some parts of ALGLIB which is a free software distributed
//under a GPL license - version 2 or (at your option) any later version.

interface

resourcestring
  rsLSRMVersion = 'LSRMTools version 2.1.2';
  rsLSRMLicense = 'Copyright 2013-2017 Ren Dahms (rene.dahms at math.ethz.ch)' + sLineBreak + sLineBreak
                  +'  LSRMTools is free software: you can redistribute it and/or modify' + sLineBreak
                  +'  it under the terms of the GNU General Public License as published by' + sLineBreak
                  +'  the Free Software Foundation, either version 3 of the License, or' + sLineBreak
                  +'  (at your option) any later version.' + sLineBreak + sLineBreak
                  +'  LSRMTools is distributed in the hope that it will be useful,' + sLineBreak
                  +'  but WITHOUT ANY WARRANTY; without even the implied warranty of' + sLineBreak
                  +'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the' + sLineBreak
                  +'  GNU General Public License for more details.' + sLineBreak + sLineBreak
                  +'  You should have received a copy of the GNU General Public License' + sLineBreak
                  +'  along with LSRMTools.  If not, see <http://www.gnu.org/licenses/>.' + sLineBreak + sLineBreak
                  +'LSRMTools use some parts of ALGLIB which is a free software distributed' + sLineBreak
                  +'under a GPL license - version 2 or (at your option) any later version.';

  rsLSRM_Gamma1Missing = 'Parameter gamma1 is missing.';
  rsLSRM_WrongGamma1 = 'Parameter gamma1 is neither a string or a two dimensional array of double with the right number of columns in the second dimension.';
  rsLSRM_WrongGamma2 = 'Parameter gamma2 is neither a string or a two dimensional array of double with the right number of columns in the second dimension.';
  rsLSRM_Gamma1Gamma2Mismatch = 'The parameters gamma1 and gamma2 do not specify the same type of LSRM, i.e. a normal or a simple LSRM.';
  rsLSRM_WrongGeometryM = 'Number of claim properties has to be greater than zero.';
  rsLSRM_WrongGeometryI = 'Number of accident periods has to be greater than zero.';
  rsLSRM_WrongGeometryJ1 = 'Number of development periods has to be greater than zero.';
  rsLSRM_WrongGeometryJ2 = 'Number of development periods has to be smaller than or equal to the number of accident periods.';
  rsLSRM_WrongGeometryK = 'Number of future development periods has to be greater then zero.';
  rsLSRM_WrongInternalParameter = 'The internal function has been called with a wrong parameter.';

  // errors regarding the formula specification of the parameters gamma 1 and gamma2
  rsLSRM_WrongFormulaGamma1_ToofewFormulas = 'The formula string for gamma1 does not contain enough formulas for exposures.';
  rsLSRM_WrongFormulaGamma1_ToomanyFormulas = 'The formula string for gamma1 does contain too many formulas for exposures.';
  rsLSRM_WrongFormulaGamma1_ParseError = 'The formula string for gamma1 does contain the following sytax error.';
  rsLSRM_WrongFormulaGamma2_ToofewFormulas = 'The formula string for gamma2 does not contain enough formulas for exposures.';
  rsLSRM_WrongFormulaGamma2_ToomanyFormulas = 'The formula string for gamma2 does contain too many formulas for exposures.';
  rsLSRM_WrongFormulaGamma2_ParseError = 'The formula string for gamma2 does contain the following sytax error.';
  rsLSRM_WrongFormula_SyntaxError = 'Syntax error at position ';
  rsLSRM_WrongFormula_ClosingBracket = 'Missing closing bracket at position ';
  rsLSRM_WrongFormula_OpeningBracket = 'Missing opening bracket at position ';
  rsLSRM_WrongFormula_MulExpected = 'Missing ''*'' after the factor at position ';
  rsLSRM_WrongFormula_MulExpected1 = 'Missing ''*'' at position ';
  rsLSRM_WrongFormula_FloatExpected = 'Invalid factor at position ';
  rsLSRM_WrongFormula_WrongClaimProperty = 'Invalid claim property at position ';
  rsLSRM_WrongFormula_EndedPremature = 'Formula ended before it was finished:';
  rsLSRM_WrongFormula_SemicolonExpected = 'Missing '';'' after the factor at position ';
  rsLSRM_WrongFormula_BrackedExpected = 'Missing '']'' after the factor at position ';
  rsLSRM_WrongFormula_ClosingBrackedMissing = 'Missing a closing bracked '']'' after position ';

  // error string for exception handling in Init methods
  rsLSRM_ErrorInitalpha = 'During the initialisation of the mixing factors alpha^m_i the following error occures:';
  rsLSRM_ErrorInitCDR = 'During the calculation of the CDR (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRProxy = 'During the calculation of the approximated CDR the following error occures:';
  rsLSRM_ErrorInitCDRTail = 'During the calculation of the tail CDR (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRTailProxy = 'During the calculation of the approximated tail CDR the following error occures:';
  rsLSRM_ErrorInitCDRParaErr = 'During the calculation of the CDR parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRParaErrDetail = 'During the calculation of the addends of the CDR parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRParaErrProxy = 'During the calculation of the approximated CDR parameter error the following error occures:';
  rsLSRM_ErrorInitCDRParaErrTail = 'During the calculation of the CDR tail parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRParaErrTailProxy = 'During the calculation of the approximated CDR tail parameter error the following error occures:';
  rsLSRM_ErrorInitCDRParaErrProxyDetail = 'During the calculation of the addends of the approximated CDR parameter error the following error occures:';
  rsLSRM_ErrorInitCDRParaErrTailDetail = 'During the calculation of the addends of the CDR tail parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRParaErrTailProxyDetail = 'During the calculation of the addends of the approximated CDR tail parameter error the following error occures:';
  rsLSRM_ErrorInitCDRProcVar = 'During the calculation of the CDR process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRProcVarDetail = 'During the calculation of the addends of the CDR process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRProcVarProxy = 'During the calculation f the approximated CDR process variance the following error occures:';
  rsLSRM_ErrorInitCDRProcVarTail = 'During the calculation f the CDR tail process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRProcVarTailProxy = 'During the calculation f the approximated CDR tail process variance the following error occures:';
  rsLSRM_ErrorInitCDRProcVarProxyDetail = 'During the calculation of the addends of the approximated CDR process variance the following error occures:';
  rsLSRM_ErrorInitCDRProcVarTailDetail = 'During the calculation of the addends of the CDR tail process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitCDRProcVarTailProxyDetail = 'During the calculation of the addends of the approximated CDR tail process variance the following error occures:';
  rsLSRM_ErrorInitCoorF = 'During the calculation of the coordinates of the operator F the following error occures:';
  rsLSRM_ErrorInitDefaultalpha = 'During the initialisation of the default (equal to 1) mixing factors alpha^m_i the following error occures:';
  rsLSRM_ErrorInitDefaultf = 'During the initialisation of the default development factors f^m_k the following error occures:';
  rsLSRM_ErrorInitDefaultsigma = 'During the initialisation of the default variance parameters sigma^m1,m2_k the following error occures:';
  rsLSRM_ErrorInitDefaultw = 'During the initialisation of the default weights w^m_i,k the following error occures:';
  rsLSRM_ErrorInitEigenvalues = 'During the initialisation of the eigenvalues and eigenvectors of the covariance matrices the following error occures:';
  rsLSRM_ErrorInitGamma1 = 'During the initialisation of the model parameters gamma^m,l_i,k,h,j the following error occures:';
  rsLSRM_ErrorInitGamma2 = 'During the initialisation of the model parameters gamma^m1,m2,l_i,k,h,j the following error occures:';
  rsLSRM_ErrorInitGeometry = 'During the initialisation of the geometry parameters M, I and J the following error occures:';
  rsLSRM_ErrorInitf = 'During the initialisation of the development factors f^m_k the following error occures:';
  rsLSRM_ErrorInitInflationRate = 'During the initialisation of the inflation rate the following error occures:';
  rsLSRM_ErrorInitMSEP = 'During the calculation of the MSEP (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPProxy = 'During the calculation of the approximated MSEP the following error occures:';
  rsLSRM_ErrorInitMSEPTail = 'During the calculation of the tail MSEP (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPTailProxy = 'During the calculation of the approximated tail MSEP the following error occures:';
  rsLSRM_ErrorInitMSEPParaErr = 'During the calculation of the MSEP parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrDetail = 'During the calculation of the addends of the MSEP parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrProxy = 'During the calculation of the approximated MSEP parameter error the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrTail = 'During the calculation of the MSEP tail parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrTailProxy = 'During the calculation of the approximated MSEP tail parameter error the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrProxyDetail = 'During the calculation of the addends of the approximated MSEP parameter error the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrTailDetail = 'During the calculation of the addends of the MSEP tail parameter error (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPParaErrTailProxyDetail = 'During the calculation of the addends of the approximated MSEP tail parameter error the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarDetail = 'During the calculation of the addends of the MSEP process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarProxyDetail = 'During the calculation of the addends of the approximated MSEP process variance the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarTailDetail = 'During the calculation of the addends of the MSEP tail process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarTailProxyDetail = 'During the calculation of the addends of the approximated MSEP tail process variance the following error occures:';
  rsLSRM_ErrorInitMSEPProcVar = 'During the calculation of the MSEP process variance the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarProxy = 'During the calculation of the approximated MSEP process variance the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarTail = 'During the calculation of the MSEP tail process variance the following error occures:';
  rsLSRM_ErrorInitMSEPProcVarTailProxy = 'During the calculation of the approximated MSEP tail process variance (without approximation) the following error occures:';
  rsLSRM_ErrorInitR1 = 'During the initialisation of the past of the exposures R^m_i,k the following error occures:';
  rsLSRM_ErrorInitR2 = 'During the initialisation of the past of the exposures R^m1,m2_i,k the following error occures:';
  rsLSRM_ErrorInitR2Full = 'During the projection of the exposures R^m1,m2_i,k the following error occures:';
  rsLSRM_ErrorInitrhoCDR = 'During the calculation of the rhos used for the CDR the following error occures:';
  rsLSRM_ErrorInitrhoMSEP = 'During the calculation of the rhos used for the MSEP the following error occures:';
  rsLSRM_ErrorInitrhoStar = 'During the calculation of the rho* the following error occures:';
  rsLSRM_ErrorInitS = 'During the initialisation of the past of the claim properties S^m_i,k the following error occures:';
  rsLSRM_ErrorInitsigma = 'During the initialisation of the variance parameters sigma^m1,m2_k the following error occures:';
  rsLSRM_ErrorInitSxS0 = 'During the calculation of SxS the following error occures:';
  rsLSRM_ErrorInitSxSCDRParaErr = 'During the calculation of H(rho*1)SxS, H(rho*2)SxS and H(rho*12)SxS the following error occures:';
  rsLSRM_ErrorInitSxSCDRProcVar = 'During the calculation of H(rho bar)SxS the following error occures:';
  rsLSRM_ErrorInitSxSMSEP = 'During the calculation of H(rho*)SxS the following error occures:';
  rsLSRM_ErrorInitw = 'During the initialisation of the weights w^m_i,k the following error occures:';
  rsLSRM_ErrorInitUltimate = 'During the projection of the ultimates the following error occures:';
  rsLSRM_ErrorInitUltimateDetail = 'During the projection of claim properties S^m_i,k and exposures R^m_i,k the following error occures:';
  rsLSRM_NonPositiveInflation = 'The specified inflation rate is not strictly positive.';
  rsLSRM_ProxyOnly = 'Since not all objects should be stored within the memory (option cLSRMReduceMemSize) we can only calculate proxies.';
  rsLSRM_AlgorithmDoesNotConverge = 'The algorithm for the canculation of the eigenvalues and eigenvectors does not converge.';
  rsLSRM_ErrorInitCDRCov = 'During the calculation of the covariance matrix of the total CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovProxy = 'During the calculation of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovTail = 'During the calculation of the covariance matrix of the total CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovTailProxy = 'During the calculation of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovParaErr = 'During the calculation of the covariance matrix of the CDR parameter error without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovParaErrProxy = 'During the calculation of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovParaErrTail = 'During the calculation of the covariance matrix of the CDR parameter error with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovParaErrTailProxy = 'During the calculation of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovProcVar = 'During the calculation of the covariance matrix of the CDR process variance without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovProcVarProxy = 'During the calculation of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovProcVarTail = 'During the calculation of the covariance matrix of the CDR process variance with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovProcVarTailProxy = 'During the calculation of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCov = 'During the calculation of the covariance matrix of the total MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovProxy = 'During the calculation of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovTail = 'During the calculation of the covariance matrix of the total MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovTailProxy = 'During the calculation of the covariance matrix of the total approximated MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovParaErr = 'During the calculation of the covariance matrix of the MSEP parameter error without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovParaErrProxy = 'During the calculation of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovParaErrTail = 'During the calculation of the covariance matrix of the MSEP parameter error with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovParaErrTailProxy = 'During the calculation of the covariance matrix of the total approximated MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovProcVar = 'During the calculation of the covariance matrix of the MSEP process variance without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovProcVarProxy = 'During the calculation of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovProcVarTail = 'During the calculation of the covariance matrix of the MSEP process variance with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovProcVarTailProxy = 'During the calculation of the covariance matrix of the total approximated MSEP with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalue = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueParaErr = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the CDR parameter error without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueParaErrProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueParaErrTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the CDR parameter error with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueParaErrTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueProcVar = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the CDR process variance without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueProcVarProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR without tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueProcVarTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the CDR process variance with tail the following error occures:';
  rsLSRM_ErrorInitCDRCovEigenvalueProcVarTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated CDR with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalue = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueParaErr = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the MSEP parameter error without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueParaErrProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueParaErrTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the MSEP parameter error with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueParaErrTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueProcVar = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the MSEP process variance without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueProcVarProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP without tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueProcVarTail = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the MSEP process variance with tail the following error occures:';
  rsLSRM_ErrorInitMSEPCovEigenvalueProcVarTailProxy = 'During the calculation of the eigenvalues and eigenvectors of the covariance matrix of the total approximated MSEP with tail the following error occures:';

  rsLSRM_ErrorOP_F = 'During a calculation with the operator F the following error occures:';
  rsLSRM_ErrorOP_H = 'During a calculation with the operator H the following error occures:';

  // error string for failed initialisation checks
  rsLSRM_NotInitialisedGeometry = 'Geometry parameters M, I and J are not yet initialised.';
  rsLSRM_NotInitialisedS = 'Claim properties are not yet initialised.';
  rsLSRM_NotInitialisedGamma1 = 'Model parameters gamma^m,l_i,k,h,j are not yet initialised.';
  rsLSRM_NotInitialisedGamma2 = 'Model parameters gamma^m1,m2,l_i,k,h,j are not yet initialised.';
  rsLSRM_NotInitialisedw = 'Weights are not yet initialised.';
  rsLSRM_NotInitialisedf = 'Development factors are not yet initialised.';
  rsLSRM_NotInitialisedsigma = 'Variance parameter are not yet initialised.';
  rsLSRM_NotInitialisedalpha = 'Mixing factors are not yet initialised.';

  // error string for the interface
  rsLSRM_LSRMNotFound = 'LSRM not found.';
  rsLSRM_NoSuchClaimProperty = 'Index of the claim property is out of range.';
  rsLSRM_NoSuchAccidentPeriod = 'Index of the accident period is out of range.';
  rsLSRM_NoSuchDevelopmentPeriod = 'Index of the development period is out of range.';
  rsLSRM_NoSuchCalcStep = 'Index of the calculation step is out of range.';
  rsLSRM_NoSuchTypeOfWeights = 'Index for the type of weights (not normalized, normalized at time I or I+1) is out of range.';
  rsLSRM_NoSuchProxy = 'Index of parameter Proxy is out of range.';
  rsLSRM_NoSuchPart = 'Index of the part of the uncertainty is out of range.';
  rsLSRM_NoSuchTail = 'Index specifying the tail is out of range.';
  rsLSRM_NoSuchEigenvalue = 'Index specifying the eigenvalue is out of range.';
  rsLSRM_NoSuchCoordinate = 'The coordinate index of tzhe eigenvector is out of range.';

  rsLSRM_UnknownError = 'Unknown error.';
  rsLSRM_IndexOutOfRange = 'Index out of range.';

// types of LSRM
  rsLSRM_NormalLSRM = 'Normal LSRM';
  rsLSRM_SimpleLSRM = 'Simplified LSRM without inflation';
  rsLSRM_InflationLSRM = 'Simplified LSRM with inflation';


implementation

end.
