﻿unit LSRMTools_TLB;

{$TYPEDADDRESS OFF} // Unit muss ohne Typüberprüfung für Zeiger compiliert werden.
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
{$ALIGN 4}

interface

uses Winapi.Windows, System.Classes, System.Variants, System.Win.StdVCL, Vcl.Graphics, Vcl.OleServer, Winapi.ActiveX;

// *********************************************************************//
// In der Typbibliothek deklarierte GUIDS. Die folgenden Präfixe werden verwendet:
//   Typbibliotheken      : LIBID_xxxx
//   CoClasses            : CLASS_xxxx
//   DISPInterfaces       : DIID_xxxx
//   Nicht-DISP-Interfaces: IID_xxxx
// *********************************************************************//
const
  // Haupt- und Nebenversionen der Typbibliothek
  LSRMToolsMajorVersion = 1;
  LSRMToolsMinorVersion = 0;

  LIBID_LSRMTools: TGUID = '{F435DC69-B8A6-430B-A37F-C499843B6E92}';

  IID_ILSRM: TGUID = '{C891DBE4-7543-46FF-95A4-B969C5A780D6}';
  CLASS_LSRM: TGUID = '{9E5FA9BA-05F3-4434-88CF-FC933D255C62}';

// *********************************************************************//
// Deklaration von in der Typbibliothek definierten Aufzählungen
// *********************************************************************//
// Konstanten für enum TLSRMInitFlags
type
  TLSRMInitFlags = TOleEnum;
const
  cLSRMInitGamma1 = $00000002;
  cLSRMInitGamma2 = $00000004;
  cLSRMInitS = $00000008;
  cLSRMInitw = $00000010;
  cLSRMUseDefaultw = $00000020;
  cLSRMInitf = $00000040;
  cLSRMUseDefaultf = $00000080;
  cLSRMInitsigma = $00000100;
  cLSRMUseDefaultsigma = $00000200;
  cLSRMInitalpha = $00000400;
  cLSRMUseDefaultalpha = $00000800;
  cLSRMInitGeometry = $00000001;
  cLSRMInitInflationRate = $00001000;
  cLSRMReduceMemSize = $00002000;
  cLSRMOverwriteExistingLSRM = $00004000;
  cLSRMVirtualTailDiversification = $00008000;
  cLSRMVirtualProcVarDiversification = $00010000;
  cLSRMVirtualParaErrDiversification = $00020000;
  cLSRMPreventPastRfromChangingSign = $00040000;
  cLSRMPreventFutureRfromChangingSign = $00080000;
  cLSRMUseWeightsForDefaultSigma = $00100000;
  cLSRMUseMSEPifTailCDRisLarger = $00200000;

type

// *********************************************************************//
// Forward-Deklaration von in der Typbibliothek definierten Typen
// *********************************************************************//
  ILSRM = interface;
  ILSRMDisp = dispinterface;

// *********************************************************************//
// Deklaration von in der Typbibliothek definierten CoClasses
// (HINWEIS: Hier wird jede CoClass ihrem Standard-Interface zugewiesen)
// *********************************************************************//
  LSRM = ILSRM;


// *********************************************************************//
// Deklaration von Strukturen, Unions und Aliasen.
// *********************************************************************//
  POleVariant1 = ^OleVariant; {*}
  PDouble1 = ^Double; {*}


// *********************************************************************//
// Interface: ILSRM
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C891DBE4-7543-46FF-95A4-B969C5A780D6}
// *********************************************************************//
  ILSRM = interface(IDispatch)
    ['{C891DBE4-7543-46FF-95A4-B969C5A780D6}']
    function Init(LSRMName: OleVariant; What: Integer; M: Integer; I: Integer; J: Integer;
                  FuturePeriods: Integer; const Gamma1: OleVariant; const Gamma2: OleVariant;
                  var S: Double; var w: Double; var f: Double; var sigma: Double;
                  var alpha: Double; var InflationRate: Double): OleVariant; safecall;
    procedure Reset(LSRMName: OleVariant); safecall;
    function Get_R1(LSRMName: OleVariant; M: Integer; I: Integer; k: Integer): OleVariant; safecall;
    function Get_S(LSRMName: OleVariant; M: Integer; I: Integer; k: Integer): OleVariant; safecall;
    function Get_R2(LSRMName: OleVariant; m1: Integer; m2: Integer; I: Integer; k: Integer): OleVariant; safecall;
    function Get_w(LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer): OleVariant; safecall;
    function Get_f(LSRMName: OleVariant; M: Integer; k: Integer): OleVariant; safecall;
    function Get_Defaultw(LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer): OleVariant; safecall;
    function Get_Defaultf(LSRMName: OleVariant; M: Integer; k: Integer): OleVariant; safecall;
    function Get_sigma(LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer): OleVariant; safecall;
    function Get_Defaultsigma(LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer): OleVariant; safecall;
    function Get_alpha(LSRMName: OleVariant; M: Integer; I: Integer): OleVariant; safecall;
    function Get_Ultimate(LSRMName: OleVariant; M: Integer; I: Integer; Tail: Integer): OleVariant; safecall;
    function Get_MSEP(LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                      Tail: Integer): OleVariant; safecall;
    function Get_MSEPDetail(LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer;
                            i2: Integer; Proxy: Integer; Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_CDR(LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                     Tail: Integer): OleVariant; safecall;
    function Get_CDRDetail(LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer;
                           i2: Integer; Proxy: Integer; Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_CalcInfo(LSRMName: OleVariant; Step: Integer; InfoType: Integer): OleVariant; safecall;
    function Get_M(LSRMName: OleVariant): OleVariant; safecall;
    function Get_I(LSRMName: OleVariant): OleVariant; safecall;
    function Get_J(LSRMName: OleVariant): OleVariant; safecall;
    function Get_Defaultalpha(LSRMName: OleVariant; M: Integer; I: Integer): OleVariant; safecall;
    function Get_DefaultwUsed(LSRMName: OleVariant): OleVariant; safecall;
    function Get_DefaultfUsed(LSRMName: OleVariant): OleVariant; safecall;
    function Get_DefaultsigmaUsed(LSRMName: OleVariant): OleVariant; safecall;
    function Get_DefaultalphaUsed(LSRMName: OleVariant): OleVariant; safecall;
    function Get_CoorF(LSRMName: OleVariant; m: Integer; i: Integer; k: Integer; l: Integer;
                       h: Integer; j: Integer): OleVariant; safecall;
    function Get_K(LSRMName: OleVariant): OleVariant; safecall;
    function Get_ModelType(LSRMName: OleVariant): OleVariant; safecall;
    function Get_CalculationFlags(LSRMName: OleVariant): OleVariant; safecall;
    function Get_Eigenvalue(LSRMName: OleVariant; i: Integer; k: Integer; m: Integer): OleVariant; safecall;
    function Get_Eigenvector(LSRMName: OleVariant; i: Integer; k: Integer; m: Integer; l: Integer): OleVariant; safecall;
    function Get_MSEPCov(LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer;
                         Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_CDRCov(LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer;
                        Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_CDRCovEigenvalue(LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                                  Tail: Integer): OleVariant; safecall;
    function Get_CDRCovEigenvector(LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                                   Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_MSEPCovEigenvalue(LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                                   Tail: Integer): OleVariant; safecall;
    function Get_MSEPCovEigenvector(LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                                    Part: Integer; Tail: Integer): OleVariant; safecall;
    function Get_About: OleVariant; safecall;
    function Get_InitialisedParameters(LSRMName: OleVariant): OleVariant; safecall;
    function Get_MaxVarCoef1: Double; safecall;
    procedure Set_MaxVarCoef1(Value: Double); safecall;
    function Get_MaxVarCoef2: Double; safecall;
    procedure Set_MaxVarCoef2(Value: Double); safecall;
    function Get_Delimiters: OleVariant; safecall;
    procedure Set_Delimiters(Value: OleVariant); safecall;
    property R1[LSRMName: OleVariant; M: Integer; I: Integer; k: Integer]: OleVariant read Get_R1;
    property S[LSRMName: OleVariant; M: Integer; I: Integer; k: Integer]: OleVariant read Get_S;
    property R2[LSRMName: OleVariant; m1: Integer; m2: Integer; I: Integer; k: Integer]: OleVariant read Get_R2;
    property w[LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer]: OleVariant read Get_w;
    property f[LSRMName: OleVariant; M: Integer; k: Integer]: OleVariant read Get_f;
    property Defaultw[LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer]: OleVariant read Get_Defaultw;
    property Defaultf[LSRMName: OleVariant; M: Integer; k: Integer]: OleVariant read Get_Defaultf;
    property sigma[LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer]: OleVariant read Get_sigma;
    property Defaultsigma[LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer]: OleVariant read Get_Defaultsigma;
    property alpha[LSRMName: OleVariant; M: Integer; I: Integer]: OleVariant read Get_alpha;
    property Ultimate[LSRMName: OleVariant; M: Integer; I: Integer; Tail: Integer]: OleVariant read Get_Ultimate;
    property MSEP[LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                  Tail: Integer]: OleVariant read Get_MSEP;
    property MSEPDetail[LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer; i2: Integer;
                        Proxy: Integer; Part: Integer; Tail: Integer]: OleVariant read Get_MSEPDetail;
    property CDR[LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                 Tail: Integer]: OleVariant read Get_CDR;
    property CDRDetail[LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer; i2: Integer;
                       Proxy: Integer; Part: Integer; Tail: Integer]: OleVariant read Get_CDRDetail;
    property CalcInfo[LSRMName: OleVariant; Step: Integer; InfoType: Integer]: OleVariant read Get_CalcInfo;
    property M[LSRMName: OleVariant]: OleVariant read Get_M;
    property I[LSRMName: OleVariant]: OleVariant read Get_I;
    property J[LSRMName: OleVariant]: OleVariant read Get_J;
    property Defaultalpha[LSRMName: OleVariant; M: Integer; I: Integer]: OleVariant read Get_Defaultalpha;
    property DefaultwUsed[LSRMName: OleVariant]: OleVariant read Get_DefaultwUsed;
    property DefaultfUsed[LSRMName: OleVariant]: OleVariant read Get_DefaultfUsed;
    property DefaultsigmaUsed[LSRMName: OleVariant]: OleVariant read Get_DefaultsigmaUsed;
    property DefaultalphaUsed[LSRMName: OleVariant]: OleVariant read Get_DefaultalphaUsed;
    property CoorF[LSRMName: OleVariant; m: Integer; i: Integer; k: Integer; l: Integer;
                   h: Integer; j: Integer]: OleVariant read Get_CoorF;
    property K[LSRMName: OleVariant]: OleVariant read Get_K;
    property ModelType[LSRMName: OleVariant]: OleVariant read Get_ModelType;
    property CalculationFlags[LSRMName: OleVariant]: OleVariant read Get_CalculationFlags;
    property Eigenvalue[LSRMName: OleVariant; i: Integer; k: Integer; m: Integer]: OleVariant read Get_Eigenvalue;
    property Eigenvector[LSRMName: OleVariant; i: Integer; k: Integer; m: Integer; l: Integer]: OleVariant read Get_Eigenvector;
    property MSEPCov[LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer; Part: Integer;
                     Tail: Integer]: OleVariant read Get_MSEPCov;
    property CDRCov[LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer; Part: Integer;
                    Tail: Integer]: OleVariant read Get_CDRCov;
    property CDRCovEigenvalue[LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                              Tail: Integer]: OleVariant read Get_CDRCovEigenvalue;
    property CDRCovEigenvector[LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                               Part: Integer; Tail: Integer]: OleVariant read Get_CDRCovEigenvector;
    property MSEPCovEigenvalue[LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                               Tail: Integer]: OleVariant read Get_MSEPCovEigenvalue;
    property MSEPCovEigenvector[LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                                Part: Integer; Tail: Integer]: OleVariant read Get_MSEPCovEigenvector;
    property About: OleVariant read Get_About;
    property InitialisedParameters[LSRMName: OleVariant]: OleVariant read Get_InitialisedParameters;
    property MaxVarCoef1: Double read Get_MaxVarCoef1 write Set_MaxVarCoef1;
    property MaxVarCoef2: Double read Get_MaxVarCoef2 write Set_MaxVarCoef2;
    property Delimiters: OleVariant read Get_Delimiters write Set_Delimiters;
  end;

// *********************************************************************//
// DispIntf:  ILSRMDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {C891DBE4-7543-46FF-95A4-B969C5A780D6}
// *********************************************************************//
  ILSRMDisp = dispinterface
    ['{C891DBE4-7543-46FF-95A4-B969C5A780D6}']
    function Init(LSRMName: OleVariant; What: Integer; M: Integer; I: Integer; J: Integer;
                  FuturePeriods: Integer; const Gamma1: OleVariant; const Gamma2: OleVariant;
                  var S: Double; var w: Double; var f: Double; var sigma: Double;
                  var alpha: Double; var InflationRate: Double): OleVariant; dispid 223;
    procedure Reset(LSRMName: OleVariant); dispid 202;
    property R1[LSRMName: OleVariant; M: Integer; I: Integer; k: Integer]: OleVariant readonly dispid 204;
    property S[LSRMName: OleVariant; M: Integer; I: Integer; k: Integer]: OleVariant readonly dispid 203;
    property R2[LSRMName: OleVariant; m1: Integer; m2: Integer; I: Integer; k: Integer]: OleVariant readonly dispid 205;
    property w[LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer]: OleVariant readonly dispid 206;
    property f[LSRMName: OleVariant; M: Integer; k: Integer]: OleVariant readonly dispid 207;
    property Defaultw[LSRMName: OleVariant; n: Integer; M: Integer; I: Integer; k: Integer]: OleVariant readonly dispid 208;
    property Defaultf[LSRMName: OleVariant; M: Integer; k: Integer]: OleVariant readonly dispid 209;
    property sigma[LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer]: OleVariant readonly dispid 210;
    property Defaultsigma[LSRMName: OleVariant; m1: Integer; m2: Integer; k: Integer]: OleVariant readonly dispid 211;
    property alpha[LSRMName: OleVariant; M: Integer; I: Integer]: OleVariant readonly dispid 212;
    property Ultimate[LSRMName: OleVariant; M: Integer; I: Integer; Tail: Integer]: OleVariant readonly dispid 213;
    property MSEP[LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                  Tail: Integer]: OleVariant readonly dispid 214;
    property MSEPDetail[LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer; i2: Integer;
                        Proxy: Integer; Part: Integer; Tail: Integer]: OleVariant readonly dispid 216;
    property CDR[LSRMName: OleVariant; M: Integer; I: Integer; Proxy: Integer; Part: Integer;
                 Tail: Integer]: OleVariant readonly dispid 218;
    property CDRDetail[LSRMName: OleVariant; m1: Integer; m2: Integer; i1: Integer; i2: Integer;
                       Proxy: Integer; Part: Integer; Tail: Integer]: OleVariant readonly dispid 220;
    property CalcInfo[LSRMName: OleVariant; Step: Integer; InfoType: Integer]: OleVariant readonly dispid 222;
    property M[LSRMName: OleVariant]: OleVariant readonly dispid 201;
    property I[LSRMName: OleVariant]: OleVariant readonly dispid 224;
    property J[LSRMName: OleVariant]: OleVariant readonly dispid 225;
    property Defaultalpha[LSRMName: OleVariant; M: Integer; I: Integer]: OleVariant readonly dispid 226;
    property DefaultwUsed[LSRMName: OleVariant]: OleVariant readonly dispid 227;
    property DefaultfUsed[LSRMName: OleVariant]: OleVariant readonly dispid 228;
    property DefaultsigmaUsed[LSRMName: OleVariant]: OleVariant readonly dispid 229;
    property DefaultalphaUsed[LSRMName: OleVariant]: OleVariant readonly dispid 230;
    property CoorF[LSRMName: OleVariant; m: Integer; i: Integer; k: Integer; l: Integer;
                   h: Integer; j: Integer]: OleVariant readonly dispid 231;
    property K[LSRMName: OleVariant]: OleVariant readonly dispid 232;
    property ModelType[LSRMName: OleVariant]: OleVariant readonly dispid 234;
    property CalculationFlags[LSRMName: OleVariant]: OleVariant readonly dispid 233;
    property Eigenvalue[LSRMName: OleVariant; i: Integer; k: Integer; m: Integer]: OleVariant readonly dispid 235;
    property Eigenvector[LSRMName: OleVariant; i: Integer; k: Integer; m: Integer; l: Integer]: OleVariant readonly dispid 236;
    property MSEPCov[LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer; Part: Integer;
                     Tail: Integer]: OleVariant readonly dispid 237;
    property CDRCov[LSRMName: OleVariant; m1: Integer; m2: Integer; Proxy: Integer; Part: Integer;
                    Tail: Integer]: OleVariant readonly dispid 238;
    property CDRCovEigenvalue[LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                              Tail: Integer]: OleVariant readonly dispid 215;
    property CDRCovEigenvector[LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                               Part: Integer; Tail: Integer]: OleVariant readonly dispid 217;
    property MSEPCovEigenvalue[LSRMName: OleVariant; m: Integer; Proxy: Integer; Part: Integer;
                               Tail: Integer]: OleVariant readonly dispid 219;
    property MSEPCovEigenvector[LSRMName: OleVariant; m: Integer; l: Integer; Proxy: Integer;
                                Part: Integer; Tail: Integer]: OleVariant readonly dispid 221;
    property About: OleVariant readonly dispid 239;
    property InitialisedParameters[LSRMName: OleVariant]: OleVariant readonly dispid 240;
    property MaxVarCoef1: Double dispid 241;
    property MaxVarCoef2: Double dispid 242;
    property Delimiters: OleVariant dispid 243;
  end;

// *********************************************************************//
// Die Klasse CoLSRM stellt die Methoden Create und CreateRemote zur
// Verfügung, um Instanzen des Standard-Interface ILSRM, dargestellt
// von CoClass LSRM, zu erzeugen. Diese Funktionen können
// von einem Client verwendet werden, der die CoClasses automatisieren
// will, die von dieser Typbibliothek dargestellt werden.
// *********************************************************************//
  CoLSRM = class
    class function Create: ILSRM;
    class function CreateRemote(const MachineName: string): ILSRM;
  end;

implementation

uses System.Win.ComObj;

class function CoLSRM.Create: ILSRM;
begin
  Result := CreateComObject(CLASS_LSRM) as ILSRM;
end;

class function CoLSRM.CreateRemote(const MachineName: string): ILSRM;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_LSRM) as ILSRM;
end;

end.

