library LSRM_Dll;

//Copyright 2013-2017 Ren Dahms (rene.dahms at math.ethz.ch)
//
//This file is part of LSRMTools.
//
//    LSRMTools is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    LSRMTools is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with LSRMTools.  If not, see <http://www.gnu.org/licenses/>.
//
//LSRMTools use some parts of ALGLIB which is a free software distributed
//under a GPL license - version 2 or (at your option) any later version.

uses
  windows,
  variants,
  SysUtils,
  Classes,
  LSRMDll in 'LSRMDll.pas',
  FormulaParser in 'FormulaParser.pas',
  LSRMDependencies in 'LSRMDependencies.pas',
  LSRMTools_RS in 'LSRMTools_RS.pas',
  LSRM in 'LSRM.pas';

{$R *.res}

exports LSRMInit,LSRMReset,LSRMAbout,LSRMR1,LSRMR2,LSRMS,LSRMw,LSRMalpha,LSRMCalcInfo,LSRMCDR,LSRMCDRDetail,
        LSRMf,LSRMDefaultf,LSRMMSEP,LSRMMSEPDetail,LSRMsigma,LSRMUltimate,LSRMDefaultw,LSRMDefaultalpha,
        LSRMI,LSRMInitialisedParameters,LSRMJ,LSRMM,LSRMDefaultsigma,LSRMDefaultalphaUsed,LSRMDefaultfUsed,
        LSRMDefaultsigmaUsed,LSRMDefaultwUsed,LSRMCoorF,LSRMK,LSRMModelType,LSRMCalculationFlags,
        LSRMEigenvalue,LSRMEigenvector,LSRMCDRCov,LSRMMSEPCov,LSRMCDRCovEigenvalue,LSRMMSEPCovEigenvalue,
        LSRMCDRCovEigenvector,LSRMMSEPCovEigenvector,LSRMMaxVarCoef1,LSRMMaxVarCoef2,LSRMSetMaxVarCoef1,LSRMSetMaxVarCoef2,
        LSRMDelimiters,LSRMSetDelimiters
        ;

procedure LibProc(Reason: Integer);
begin
  case Reason of
    DLL_PROCESS_DETACH: begin
      LSRMDestroy;
    end;
    DLL_Process_Attach: begin
      LSRMInitialize;
    end;
    DLL_Thread_Attach: begin

    end;
    DLL_Thread_Detach: begin

    end;
  end;
end;

begin
  DllProc := @LibProc;
  DllProc(Dll_Process_Attach);
end.
